.\"     Title: abc::sat
.\"    Author: Jan CTU in Prague Schmidt <jan.schmidt@fit.cvut.cz>
.\" Generator: DocBook XSL Stylesheets v1.74.0 <http://docbook.sf.net/>
.\"      Date: 12/21/2010
.\"    Manual: Reference Pages
.\"    Source: ABCTcl 0.6
.\"  Language: English
.\"
.TH "ABC::SAT" "n" "12/21/2010" "ABCTcl 0.6" "Reference Pages"
.\" -----------------------------------------------------------------
.\" * (re)Define some macros
.\" -----------------------------------------------------------------
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" toupper - uppercase a string (locale-aware)
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de toupper
.tr aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ
\\$*
.tr aabbccddeeffgghhiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SH-xref - format a cross-reference to an SH section
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de SH-xref
.ie n \{\
.\}
.toupper \\$*
.el \{\
\\$*
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SH - level-one heading that works better for non-TTY output
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de1 SH
.\" put an extra blank line of space above the head in non-TTY output
.if t \{\
.sp 1
.\}
.sp \\n[PD]u
.nr an-level 1
.set-an-margin
.nr an-prevailing-indent \\n[IN]
.fi
.in \\n[an-margin]u
.ti 0
.HTML-TAG ".NH \\n[an-level]"
.it 1 an-trap
.nr an-no-space-flag 1
.nr an-break-flag 1
\." make the size of the head bigger
.ps +3
.ft B
.ne (2v + 1u)
.ie n \{\
.\" if n (TTY output), use uppercase
.toupper \\$*
.\}
.el \{\
.nr an-break-flag 0
.\" if not n (not TTY), use normal case (not uppercase)
\\$1
.in \\n[an-margin]u
.ti 0
.\" if not n (not TTY), put a border/line under subheading
.sp -.6
\l'\n(.lu'
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SS - level-two heading that works better for non-TTY output
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de1 SS
.sp \\n[PD]u
.nr an-level 1
.set-an-margin
.nr an-prevailing-indent \\n[IN]
.fi
.in \\n[IN]u
.ti \\n[SN]u
.it 1 an-trap
.nr an-no-space-flag 1
.nr an-break-flag 1
.ps \\n[PS-SS]u
\." make the size of the head bigger
.ps +2
.ft B
.ne (2v + 1u)
.if \\n[.$] \&\\$*
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" BB/BE - put background/screen (filled box) around block of text
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de BB
.if t \{\
.sp -.5
.br
.in +2n
.ll -2n
.gcolor red
.di BX
.\}
..
.de EB
.if t \{\
.if "\\$2"adjust-for-leading-newline" \{\
.sp -1
.\}
.br
.di
.in
.ll
.gcolor
.nr BW \\n(.lu-\\n(.i
.nr BH \\n(dn+.5v
.ne \\n(BHu+.5v
.ie "\\$2"adjust-for-leading-newline" \{\
\M[\\$1]\h'1n'\v'+.5v'\D'P \\n(BWu 0 0 \\n(BHu -\\n(BWu 0 0 -\\n(BHu'\M[]
.\}
.el \{\
\M[\\$1]\h'1n'\v'-.5v'\D'P \\n(BWu 0 0 \\n(BHu -\\n(BWu 0 0 -\\n(BHu'\M[]
.\}
.in 0
.sp -.5v
.nf
.BX
.in
.sp .5v
.fi
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" BM/EM - put colored marker in margin next to block of text
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de BM
.if t \{\
.br
.ll -2n
.gcolor red
.di BX
.\}
..
.de EM
.if t \{\
.br
.di
.ll
.gcolor
.nr BH \\n(dn
.ne \\n(BHu
\M[\\$1]\D'P -.75n 0 0 \\n(BHu -(\\n[.i]u - \\n(INu - .75n) 0 0 -\\n(BHu'\M[]
.in 0
.nf
.BX
.in
.fi
.\}
..
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "Name"
abc::sat, abc::iprove, abc::prove \- check staisfiability
.SH "Synopsis"
.fam C
.HP \w'\fBabc::sat\fR\ 'u
\fBabc::sat\fR [\fIresult\fR] [\fIparameters\fR] [\fItimeout\fR]
.fam
.fam C
.HP \w'\fBabc::iprove\fR\ 'u
\fBabc::iprove\fR [\fIresult\fR] [\fIparameters\fR] [\fItimeout\fR]
.fam
.fam C
.HP \w'\fBabc::prove\fR\ 'u
\fBabc::prove\fR [\fIresult\fR] [\fIparameters\fR] [\fItimeout\fR]
.fam
.SH "DESCRIPTION"
.PP
The procedures take a combinational circuit and determines whether there exist a combination of input values that results in logical 1 at the output\&. This is known as the Boolean Satisfiability Problem (SAT)\&. The procedures send respective commands together with
\fIparameters\fR
to
ABC
and wait for a prompt\&. The output is parsed to determine the result and detect error messages from
ABC\&. The result is returned by symbolic return codes\&.
.SH "ARGUMENTS"
.PP
array \fIresult \fR(out)
.RS 4
Optional argument\&. If omitted, no information is returned\&. The following items are present:
.PP
string \fIerrorCode\fR (out)
.RS 4
Error code\&. See
\c
.SH-xref "RETURN CODES\c"
\&
below\&. Also put to the
\fIerrorCode\fR
global variable\&.
.RE
.PP
string \fIrawOutput\fR (out)
.RS 4
The unprocessed output of
ABC, including the final prompt\&.
.RE
.PP
int \fIpromptNumber \fR(out)
.RS 4
The number included in the final prompt\&. The ABC prompt has the "abc123> " form\&. The number indicates successive version of the network stored in
ABC\&.
.RE
.PP
int \fIcmdTime \fR(out)
.RS 4
Time in milliseconds elapsed by the command\&.
.RE
.PP
string \fIanswer \fR(out)
.RS 4
The result of the equivalence check\&. Also provided as the return value of the procedures\&. One of
ABC_N_SAT_YES,
ABC_N_SAT_NO,
ABC_N_SAT_UND\&.
.RE
.RE
.PP
string \fIparameters \fR(in)
.RS 4
Optional argument\&. Parameters for the respective
ABC
commands\&. Defaults to an empty string\&.
.RE
.PP
int \fItimeout \fR(in)
.RS 4
Optional argument\&. If given, sets the timeout of
Expect
for this command\&. Othervise, the value of the
\fItimeout\fR
global variable applies\&.
.RE
.SH "RETURN CODES"
.PP
The procedures returns a string representing the result, or an empty string in case of error\&. The returned symbol is one of
.\" line length increase to cope w/ tbl weirdness
.ll +(\n(LLu * 62u / 100u)
.TS
ll.
\fISymbol\fR	\fIMeaning\fR
T{
ABC_N_SAT_YES
T}	T{
This instance of the SAT problem is satisfiable\&.
T}
T{
ABC_N_SAT_NO
T}	T{
This instance of the SAT problem is unsatisfiable\&.
T}
T{
ABC_N_SAT_UND
T}	T{
The satisfiability of this instance could not be established\&.
T}
.TE
.\" line length decrease back to previous value
.ll -(\n(LLu * 62u / 100u)
.PP
See
\fBabctcl\fR(n),
\fBabc::messages\fR(n)
for error reporting and error symbols\&. The following error symbols can occur:
.\" line length increase to cope w/ tbl weirdness
.ll +(\n(LLu * 62u / 100u)
.TS
ll.
\fIError Code\fR	\fIDiagnostic\fR
T{
ABC_E_BUSY
T}	T{
Prompt from the previous command has not been detected yet\&.
T}
T{
ABC_E_EOF
T}	T{
A premature end\-of\-file detected\&. Perhaps the ABC process crashed\&.
T}
T{
ABC_E_TOUT
T}	T{
Timeout expired before the prompt was detected\&.
T}
T{
ABC_E_PARAMS
T}	T{
ABC could not interpret \fIparameters\fR\&.
T}
T{
ABC_E_PARSE
T}	T{
The procedure could not parse the output of ABC\&. A new version with different labels might be in use\&.
T}
T{
ABC_E_EMPTY
T}	T{
The current circuit description in ABC is empty\&. Use \fBabc::read\fR\&.
T}
.TE
.\" line length decrease back to previous value
.ll -(\n(LLu * 62u / 100u)
.sp
.SH "BUGS"
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
The message `abc: src/base/abci/abcSat\&.c:58: Abc_NtkMiterSat: Assertion `Abc_NtkLatchNum(pNtk) == 0\' failed\&. Aborted\' (which means that the circuit contains latches) is not detected\&.
.RE
.SH "SEE ALSO"
.PP

\fBabctcl\fR(n),
\fBabc::messages\fR(n)
.SH "Author"
.PP
\fBJan CTU in Prague Schmidt\fR <\&jan\&.schmidt@fit\&.cvut\&.cz\&>
.br
CTU in Prague
.RS 4
Wrote manual pages after the original description by Jan Petr, CTU in Prague
.RE
